import oscP5.*;
import netP5.*;
import processing.serial.*; 

OscP5 oscP5;
NetAddress myRemoteLocation;
Serial myPort;  // Create object from Serial class
int counter = 0;
int counter2 = 0;

void setup() {
//MUNDERKENNUNG
  size(640, 480);                                                        // Bildgröße
  video = new Capture(this, 640/2, 480/2, "Logitech HD Webcam C270");    // Starte Video
  opencv = new OpenCV(this, 640/2, 480/2);                               
  opencv.loadCascade(OpenCV.CASCADE_MOUTH);                              // Lade Munderkennungssoftware

  video.start();                                                         // Starte Bildschirmausgabe (Video)


//DATENÜBERTRAGUNG
  frameRate(25);
  oscP5 = new OscP5(this,8000);                        // starte oscP5, warte auf Nachrichten über Port 8000
  String portName = Serial.list()[0];                  // change to the 0 port
  myPort = new Serial(this, portName, 19200);
                       //NetAddress("IP Adresse", Port)
  myRemoteLocation = new NetAddress("127.0.0.1",12000);
//myRemoteLocation --> Parameter um OSC Pakete über netAddress an andere Geräte zu senden
}

void mousePressed() {
  OscMessage myMessage = new OscMessage("/test");      // erstelle neue OSC Nachricht
  myMessage.add(123);                                  // füge einen int-Wert hinzu
  oscP5.send(myMessage, myRemoteLocation);             // sende Nachricht 
}

/* incoming osc message are forwarded to the oscEvent method. */
void oscEvent(OscMessage theOscMessage) {              // Funktion für eingehende Nachrichten
  if (counter>=2){                                     // Counter für toggle/button Zustand
    counter = 0;
  }
  if (counter2>=2){                                    // zweiter counter für anderen toggle/button
    counter2 = 0;
  }
  
  /* print the address pattern and the typetag of the received OscMessage */

  if(theOscMessage.checkAddrPattern("/1/toggle1")){
    counter2 = counter2 + 1;
    print("Toggle was used\n");
    println(counter2);
    if(counter2 == 1){
      myPort.write('K'+str(winkelServo1)+'L'+str(winkelServo2)+'M'+str(winkelServo3)+"\n");
                                                       //Übergib die Drehwinkel der Servos an Arduino

  }

/*     float servo1 = 90.0;
     float servo2 = 90.0;
     float servo3 = 90.0;
 
     myPort.write('K'+str(servo1)+"\n");
     myPort.write('L'+str(servo2)+"\n");
     myPort.write('M'+str(servo3)+"\n"); */

    else{
      myPort.write('S');
    }
    
  }
  else if(theOscMessage.checkAddrPattern("/1/push1")){
   counter = counter + 1;
  
    print("The button has been pressed\n");

//MAGNETVENTIL
   if(counter == 1){            //wenn App 1 sendet
     myPort.write('A');         //sende A = AUF
   println(counter);   
  } 
  else {                        //wenn nicht, dann 
  myPort.write('Z');            //sende Z = ZU
  println('2');                 
    }
  }
}